// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Bot.Connector
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;

    /// <summary>
    /// A card representing a request to signing
    /// </summary>
    public partial class SigninCard
    {
        /// <summary>
        /// Initializes a new instance of the SigninCard class.
        /// </summary>
        public SigninCard() { }

        /// <summary>
        /// Initializes a new instance of the SigninCard class.
        /// </summary>
        public SigninCard(string text = default(string), IList<CardAction> buttons = default(IList<CardAction>))
        {
            Text = text;
            Buttons = buttons;
        }

        /// <summary>
        /// Text for signin request
        /// </summary>
        [JsonProperty(PropertyName = "text")]
        public string Text { get; set; }

        /// <summary>
        /// Action to use to perform signin
        /// </summary>
        [JsonProperty(PropertyName = "buttons")]
        public IList<CardAction> Buttons { get; set; }

        /// <summary>
        /// Creates a <see cref="SigninCard"/>
        /// </summary>
        /// <param name="text"> The <see cref="Text"/></param>
        /// <param name="buttonLabel"> The signin button label.</param>
        /// <param name="url"> The sigin url.</param>
        /// <returns> The created sigin card.</returns>
        public static SigninCard Create(string text, string buttonLabel, string url)
        {
            return new SigninCard
            {
                Text = text,
                Buttons = new List<CardAction>
                {
                    new CardAction
                    {
                       Title =  buttonLabel,
                       Type =  ActionTypes.Signin,
                       Value =  url
                    }
                }
            };
        }
    }
}
