# Bot Builder SDK

The Microsoft Bot Builder SDK is one of three main components of the Microsoft Bot Framework.

The Microsoft Bot Framework provides just what you need to build and connect intelligent bots that interact naturally wherever your users are talking, from text/sms to Skype, Slack, Office 365 mail and other popular services.

![Bot Framework Diagram](http://docs.botframework.com/en-us/images/faq-overview/botframework_overview_july.png)

Bots (or conversation agents) are rapidly becoming an integral part of one’s digital experience – they are as vital a way for users to interact with a service or application as is a web site or a mobile experience. Developers writing bots all face the same problems: bots require basic I/O; they must have language and dialog skills; and they must connect to users – preferably in any conversation experience and language the user chooses. The Bot Framework provides tools to easily solve these problems and more for developers e.g., automatic translation to more than 30 languages, user and conversation state management, debugging tools, an embeddable web chat control and a way for users to discover, try, and add bots to the conversation experiences they love.

**[Review the documentation](http://docs.botframework.com)** to get started with the Bot Builder SDK!

Join the conversation on **[Gitter] (https://gitter.im/Microsoft/BotBuilder)**.

See all the support options **[here](https://docs.botframework.com/en-us/support/)**.
